# 开发者代码审查指南

## 简介 {#intro}

代码审查是除了代码作者之外，其他人检查代码的过程。

Google 通过 Code Review 来维护代码和产品质量。

此文档是 Google Code Review 流程和政策的规范说明。

此页面是我们进行 Code Review 流程的概述。本指南还有另外两套文档：

-   **[如何进行 Code Review](reviewer/)**：针对代码审查者的详细指南。
-   **[代码开发者指南](developer/)**：针对 CL 开发者的的详细指南。

## 代码审查者应该关注哪些方面？ {#look_for}

代码审查时应该关注以下方面：

-   **设计**：代码是否经过精心设计并适合您的系统？
-   **功能**：代码的行为是否与作者的意图相同？代码是否可以正常响应用户的行为？
-   **复杂度**：代码能更简单吗？将来其他开发人员能轻松理解并使用此代码吗？
-   **测试**：代码是否具有正确且设计良好的自动化测试？
-   **命名**：开发人员是否为变量、类、方法等选择了明确的名称？
-   **注释**：评论是否清晰有用？
-   **风格**：代码是否遵守了[风格指南](http://google.github.io/styleguide/)？
-   **文档**：开发人员是否同时更新了相关文档？

参阅**[如何进行 Code Review](reviewer/)** 获取更多资料。

### 选择最合适审查者 {#best_reviewers}

一般而言，您希望找到能在合理的时间内回复您的评论的最合适的审查者。

最合适的审查者应该是能彻底了解和审查您代码的人。他们通常是代码的所有者，可能是  OWNERS 文件中的人，也可能不是。有时 CL 的不同部分可能需要不同的人审查。

如果您找到了理想的审查者但他们又没空，那您也至少要抄送他们。

### 面对面审查 {#in_person}

如果您与有资格做代码审查的人一起结对编程了一段代码，那么该代码将被视为已审查。

您还可以进行面对面的代码审查，审查者提问，CL 的开发人员作答。

## 参考 {#seealso}

-   [如何进行 Code Review](reviewer/)：针对代码审查者的详细指南。
-   [代码开发者指南](developer/)：针对 CL 开发者的的详细指南。
